# Conditional build:
%bcond_without	dynamic		# link utilities dynamically
#
Summary:	iSCSI - SCSI over IP
Summary(pl.UTF-8):	iSCSI - SCSI po IP
Name:		open-iscsi
Version:	2.1.3
Release:	2
License:	GPL v2
Group:		Networking/Daemons
Source0:	https://github.com/open-iscsi/open-iscsi/archive/%{version}.tar.gz
# Source0-md5:	b0bcc6a6658a3862bba66274ca973346
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}-devices.init
Source4:	iscsiuio.logrotate
Patch0:		0002-idmb_rec_write-check-for-tpgt-first.patch
Patch1:		0003-idbm_rec_write-seperate-old-and-new-style-writes.patch
Patch2:		0004-idbw_rec_write-pick-tpgt-from-existing-record.patch
Patch3:		0005-update-initscripts-and-docs.patch
Patch4:		0006-use-var-for-config.patch
Patch5:		0008-libiscsi.patch
Patch6:		0009-Add-macros-to-release-GIL-lock.patch
Patch7:		0010-libiscsi-introduce-sessions-API.patch
Patch8:		0011-libiscsi-fix-discovery-request-timeout-regression.patch
Patch9:	0012-libiscsi-format-security-build-errors.patch
Patch10:	0013-libiscsi-fix-build-to-use-libopeniscsiusr.patch
Patch11:	0014-libiscsi-fix-build-against-latest-upstream-again.patch
Patch12:	0015-remove-the-offload-boot-supported-ifdef.patch
Patch13:	0016-Revert-iscsiadm-return-error-when-login-fails.patch
Patch14:	0017-dont-install-scripts.patch
Patch15:	0018-use-var-lib-iscsi-in-libopeniscsiusr.patch
Patch16:	0019-Coverity-scan-fixes.patch
Patch17:	0020-fix-upstream-build-breakage-of-iscsiuio-LDFLAGS.patch
Patch18:	0022-iscsi_if.h-replace-zero-length-array-with-flexible-a.patch
Patch19:	0023-stop-using-Werror-for-now.patch
URL:		http://www.open-iscsi.com/
BuildRequires:	kmod-devel
BuildRequires:	libisns-devel
BuildRequires:	openssl-devel
BuildRequires:	rpmbuild(macros) >= 1.671
%if %{with dynamic}
BuildRequires:	openslp-devel
BuildRequires:	sed >= 4.0
Requires:	%{name}-libs = %{version}-%{release}
Requires:	openslp >= 2.0.0
%else
BuildRequires:	glibc-static
BuildRequires:	openslp-static
%endif
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
Suggests:	multipath-tools
Provides:	group(iscsi)
Provides:	user(iscsi)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/usr/sbin

%description
The Linux iSCSI driver acts as an iSCSI protocol initiator to
transport SCSI requests and responses over an IP network between the
client and an iSCSI-enabled target device such as a Cisco SN 5420
storage router. The iSCSI protocol is an IETF-defined protocol for IP
storage. For more information about the iSCSI protocol, refer to the
IETF standards for IP storage at <http://www.ietf.org/>.

%description -l pl.UTF-8
Sterownik Linux iSCSI zachowuje się jak inicjator protokołu iSCSI do
transportu zleceń SCSI i odpowiedzi po sieci IP między klientem a
urządzeniem docelowym obsługującym iSCSI, takim jak Cisco SN 5420.
Protokół iSCSI jest zdefiniowany przez IETF do składowania IP. Więcej
informacji o protokole iSCSI znajduje się w standardach IETF na
<http://www.ietf.org/>.

%package libs
Summary:	open-iscsi libraries
Summary(pl.UTF-8):	Biblioteki open-isci
Group:		Libraries

%description libs
open-iscsi libraries

%description libs -l pl.UTF-8
Biblioteki open-isci

%package devel
Summary:	Files needed for developing with open-iscsi
Summary(pl.UTF-8):	Pliki niezbędne do tworzenia aplikacji z użyciem open-iscsi
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Files needed for building applications with open-iscsi

%description devel -l pl.UTF-8
Pliki niezbędne do tworzenia aplikacji z użyciem open-iscsi

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1

%if %{with dynamic}
sed -i -e 's/-static //' usr/Makefile
%endif

%build
cd iscsiuio
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--without-systemd
cd ..
%{__make} \
	CC="%{__cc}" \
	OPTFLAGS="%{rpmcflags} %{rpmcppflags} -DUSE_KMOD -lkmod -DNO_SYSTEMD" \
	IPC_FLAGS="-DNETLINK_ISCSI=8 -D_GNU_SOURCE" \
	KSUBLEVEL=0

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_sysconfdir}/iscsi/{nodes,send_targets,static,isns,slp,ifaces} \
	$RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig,logrotate.d}

#%{__make} install_libopeniscsiusr install_programs install_doc install_etc \
#	DESTDIR=$RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

:> $RPM_BUILD_ROOT%{_sysconfdir}/iscsi/initiatorname.iscsi

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/iscsid
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/iscsi
install %{SOURCE3} $RPM_BUILD_ROOT/etc/rc.d/init.d/iscsi
install %{SOURCE4} $RPM_BUILD_ROOT/etc/logrotate.d/iscsiuio

install usr/iscsistart $RPM_BUILD_ROOT%{_sbindir}
install doc/iscsistart.8 $RPM_BUILD_ROOT%{_mandir}/man8
install doc/iscsi-iname.8 $RPM_BUILD_ROOT%{_mandir}/man8

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 223 iscsi
%useradd -u 223 -d /tmp -s /bin/false -c "iSCSI Daemon" -g iscsi iscsi

%post
if ! grep -q "^InitiatorName=[^ \t\n]" %{_sysconfdir}/iscsi/initiatorname.iscsi 2>/dev/null; then
	echo "InitiatorName=$(iscsi-iname)" >> %{_sysconfdir}/iscsi/initiatorname.iscsi
fi
/sbin/chkconfig --add iscsi
/sbin/chkconfig --add iscsid
NORESTART=1

%preun
if [ "$1" = "0" ]; then
	%service iscsid stop
	%service iscsi stop
	/sbin/chkconfig --del iscsid
	/sbin/chkconfig --del iscsi
fi

%postun
if [ "$1" = "0" ]; then
	%userremove iscsi
	%groupremove iscsi
fi

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc Changelog README THANKS
%dir %{_sysconfdir}/iscsi
%dir %{_sysconfdir}/iscsi/ifaces
%dir %{_sysconfdir}/iscsi/isns
%dir %{_sysconfdir}/iscsi/nodes
%dir %{_sysconfdir}/iscsi/send_targets
%dir %{_sysconfdir}/iscsi/slp
%dir %{_sysconfdir}/iscsi/static
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/iscsi/iscsid.conf
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/iscsi/initiatorname.iscsi
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/iscsi
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/iscsiuio
%attr(754,root,root) /etc/rc.d/init.d/iscsi
%attr(754,root,root) /etc/rc.d/init.d/iscsid
%attr(755,root,root) %{_sbindir}/iscsi-iname
%attr(755,root,root) %{_sbindir}/iscsiadm
%attr(755,root,root) %{_sbindir}/iscsid
%attr(755,root,root) %{_sbindir}/iscsistart
%attr(755,root,root) %{_sbindir}/iscsiuio
%{_mandir}/man8/iscsi-iname.8*
%{_mandir}/man8/iscsi_discovery.8*
%{_mandir}/man8/iscsiadm.8*
%{_mandir}/man8/iscsid.8*
%{_mandir}/man8/iscsistart.8*
%{_mandir}/man8/iscsiuio.8*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libopeniscsiusr.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libopeniscsiusr.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libopeniscsiusr.so
%{_includedir}/libopeniscsiusr.h
%{_includedir}/libopeniscsiusr_common.h
%{_includedir}/libopeniscsiusr_iface.h
%{_includedir}/libopeniscsiusr_node.h
%{_includedir}/libopeniscsiusr_session.h
%{_pkgconfigdir}/libopeniscsiusr.pc
%changelog
* Sat Jan 02 2021 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/open-iscsi.git;a=log;h=master

* Sat Jan 02 2021 Marcin Krol <hawk@tld-linux.org> 2e3e23c
- package libs and devel files

* Sat Jan 02 2021 Marcin Krol <hawk@tld-linux.org> f6eb029
- updated to 2.1.3, added patches from Fedora (TLDized a bit)

* Thu Jul 30 2015 Marcin Krol <hawk@tld-linux.org> a88fb7d
- more systemd stuff dropped

* Thu Jul 30 2015 Marcin Krol <hawk@tld-linux.org> 6a812b5
- fix patches

* Thu Jul 30 2015 Marcin Krol <hawk@tld-linux.org> c2ed1a7
- drop systemd stuff

* Thu Jul 30 2015 Marcin Krol <hawk@tld-linux.org> ee1435f
- from PLD

